/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dom;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class DOMSample {
    private Document doc;
    
    private void load(String file) {
        try {
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            doc = db.parse(file);
        } catch (SAXException ex) {
            Logger.getLogger(DOMSample.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(DOMSample.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(DOMSample.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void transform() {
        NodeList nodes = doc.getElementsByTagName("b");
        for(int i=0 ; i < nodes.getLength() ; i++){
            Node node = nodes.item(i);
            if(node instanceof Element){
                Element element = (Element)node;
                if(element.getTextContent().equals("dva")){
                    element.setTextContent("zmena je zivot");
                }
            }
        }
        nodes = doc.getElementsByTagName("a");
        
        Element element = (Element)nodes.item(0);
        Node attr = element.getAttributeNode("moje");
        element.removeAttribute("moje");

        nodes = doc.getElementsByTagName("c");
        Node parent = nodes.item(0).getParentNode();
        parent.removeChild(nodes.item(0));
    }

    private void save(String output) {
        try {
            TransformerFactory tf = TransformerFactory.newInstance();
            Transformer trans = tf.newTransformer();
            trans.transform(new DOMSource(doc.getDocumentElement()), new StreamResult(new File(output)));
        } catch (TransformerException ex) {
            Logger.getLogger(DOMSample.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public static void main(String[] args){
        DOMSample sample = new DOMSample();
        if(args.length<2){
            System.err.println("Chybi parametry.");
            System.exit(-1);
        }
        sample.load(args[0]);
        sample.transform();
        sample.save(args[1]);
    }



}
