/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package validator;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 *
 * @author bar
 */
public class Validator {

    public static void main(String[] args){
        if(args.length!=1){
            System.err.println("Required the name of the file to be validated.");
            System.exit(-1);
        }
        try {
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            dbf.setValidating(true);
            DocumentBuilder db = dbf.newDocumentBuilder();
            db.setErrorHandler(new ErrorHandler());
            db.parse(new File(args[0]));
            System.out.println("File " + args[0] + " is valid.");
        } catch (SAXException ex) {
            System.out.println("File " + args[0] + " is not valid.");
           // Logger.getLogger(Validator.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Validator.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(Validator.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}

class ErrorHandler implements org.xml.sax.ErrorHandler{

    public void warning(SAXParseException exception) throws SAXException {
        System.err.println("Warning: " + exception.getMessage());
    }

    public void error(SAXParseException exception) throws SAXException {
        System.err.println(exception.getMessage());
        throw new SAXException("Invalid file", exception);
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        System.err.println("Fatal error:" + exception);
        throw new SAXException("Invalid file", exception);
    }

}